# Copyright 2021- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import api, fields, models


class AccountInvoice(models.Model):
    _inherit = "account.move"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------
    user_second_ids = fields.Many2many(
        comodel_name="res.users",
        column1="invoice_id",
        column2="user_id",
        string="Spécialistes",
        tracking=True,
        copy=False,
    )
    user_provider_id = fields.Many2one(
        "res.partner", string="Apporteur", tracking=True, copy=False
    )

    # add partner tags
    partner_category_ids = fields.Many2many(
        related="partner_id.category_id", string="Etiquettes du contact"
    )

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------
    @api.onchange("partner_id")
    def _update_invoice_default_sale_person(self):
        for move in self.filtered("partner_id"):
            move.invoice_user_id = move.partner_id.user_id or self.env.user

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
