# Copyright 2021- Le Filament (https://le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models


class SaleOrder(models.Model):
    _inherit = "sale.order"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------
    user_second_ids = fields.Many2many(
        comodel_name="res.users",
        column1="order_id",
        column2="user_id",
        string="Spécialistes",
        tracking=True,
        copy=False,
    )
    user_provider_id = fields.Many2one(
        "res.partner", string="Apporteur", tracking=True, copy=False
    )

    # add partner tags
    partner_category_ids = fields.Many2many(
        related="partner_id.category_id", string="Etiquettes du client"
    )

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
    def _prepare_invoice(self):
        values = super()._prepare_invoice()
        values.update(
            {
                "user_second_ids": [fields.Command.set(self.user_second_ids.ids)]
                if self.user_second_ids
                else False,
                "user_provider_id": self.user_provider_id.id or False,
            }
        )
        return values
